Index: trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp	(revision 34029)
+++ trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp	(revision 34030)
@@ -760,48 +760,4 @@
 
 /**
- * Write locks the object.
- *
- * @param   pThis               The object to lock.
- */
-DECLINLINE(void) rtVfsObjWriteLock(RTVFSOBJINTERNAL *pThis)
-{
-    RTVfsLockAcquireWrite(pThis->hLock);
-}
-
-
-/**
- * Undoing the effects of rtVfsObjWriteLock.
- *
- * @param   pThis               The object to lock.
- */
-DECLINLINE(void) rtVfsObjWriteUnlock(RTVFSOBJINTERNAL *pThis)
-{
-    RTVfsLockReleaseWrite(pThis->hLock);
-}
-
-/**
- * Read locks the object.
- *
- * @param   pThis               The object to lock.
- */
-DECLINLINE(void) rtVfsObjReadLock(RTVFSOBJINTERNAL *pThis)
-{
-    RTVfsLockAcquireRead(pThis->hLock);
-}
-
-
-/**
- * Undoing the effects of rtVfsObjReadLock.
- *
- * @param   pThis               The object to lock.
- */
-DECLINLINE(void) rtVfsObjReadUnlock(RTVFSOBJINTERNAL *pThis)
-{
-    RTVfsLockReleaseRead(pThis->hLock);
-}
-
-
-
-/**
  * Internal object retainer that asserts sanity in strict builds.
  *
@@ -840,5 +796,5 @@
      * Invalidate the object.
      */
-    rtVfsObjWriteLock(pThis);           /* paranoia */
+    RTVfsLockAcquireWrite(pThis->hLock);    /* paranoia */
     void *pvToFree = NULL;
     switch (enmType)
@@ -887,5 +843,5 @@
     }
     ASMAtomicWriteU32(&pThis->uMagic, RTVFSOBJ_MAGIC_DEAD);
-    rtVfsObjWriteUnlock(pThis);
+    RTVfsLockReleaseWrite(pThis->hLock);
 
     /*
@@ -1128,7 +1084,7 @@
     AssertReturn(pThis->uMagic == RTVFSOBJ_MAGIC, VERR_INVALID_HANDLE);
 
-    rtVfsObjReadLock(pThis);
+    RTVfsLockAcquireRead(pThis->hLock);
     int rc = pThis->pOps->pfnQueryInfo(pThis->pvThis, pObjInfo, enmAddAttr);
-    rtVfsObjReadUnlock(pThis);
+    RTVfsLockReleaseRead(pThis->hLock);
     return rc;
 }
@@ -1412,7 +1368,7 @@
     /** @todo Union mounts, traversal optimization methods, races, ++ */
     RTVFSDIRINTERNAL *pCurDir;
-    rtVfsObjReadLock(&pThis->Base);
+    RTVfsLockAcquireRead(pThis->Base.hLock);
     int rc = pThis->pOps->pfnOpenRoot(pThis->Base.pvThis, &pCurDir);
-    rtVfsObjReadUnlock(&pThis->Base);
+    RTVfsLockReleaseRead(pThis->Base.hLock);
     if (RT_FAILURE(rc))
         return rc;
@@ -1447,7 +1403,7 @@
         if (fFinal)
         {
-            rtVfsObjReadLock(&pCurDir->Base);
+            RTVfsLockAcquireRead(pCurDir->Base.hLock);
             rc = pCurDir->pOps->pfnTraversalOpen(pCurDir->Base.pvThis, pszEntry, NULL, &hSymlink, NULL);
-            rtVfsObjReadUnlock(&pCurDir->Base);
+            RTVfsLockReleaseRead(pCurDir->Base.hLock);
             *pszEntryEnd = '\0';
             if (rc == VERR_PATH_NOT_FOUND)
@@ -1464,7 +1420,7 @@
         else
         {
-            rtVfsObjReadLock(&pCurDir->Base);
+            RTVfsLockAcquireRead(pCurDir->Base.hLock);
             rc = pCurDir->pOps->pfnTraversalOpen(pCurDir->Base.pvThis, pszEntry, &hDir, &hSymlink, &hVfsMnt);
-            rtVfsObjReadUnlock(&pCurDir->Base);
+            RTVfsLockReleaseRead(pCurDir->Base.hLock);
             *pszEntryEnd = '/';
             if (RT_FAILURE(rc))
@@ -1515,7 +1471,7 @@
                 /* Must restart from the root (optimize this). */
                 RTVfsDirRelease(pCurDir);
-                rtVfsObjReadLock(&pThis->Base);
+                RTVfsLockAcquireRead(pThis->Base.hLock);
                 rc = pThis->pOps->pfnOpenRoot(pThis->Base.pvThis, &pCurDir);
-                rtVfsObjReadUnlock(&pThis->Base);
+                RTVfsLockReleaseRead(pThis->Base.hLock);
                 if (RT_FAILURE(rc))
                 {
@@ -1532,7 +1488,7 @@
              */
             RTVfsDirRelease(pCurDir);
-            rtVfsObjReadLock(&hVfsMnt->Base);
+            RTVfsLockAcquireRead(hVfsMnt->Base.hLock);
             rc = pThis->pOps->pfnOpenRoot(hVfsMnt->Base.pvThis, &pCurDir);
-            rtVfsObjReadUnlock(&hVfsMnt->Base);
+            RTVfsLockReleaseRead(hVfsMnt->Base.hLock);
             if (RT_FAILURE(rc))
             {
@@ -1758,7 +1714,7 @@
     AssertReturn(pThis->uMagic == RTVFSSYMLINK_MAGIC, VERR_INVALID_HANDLE);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnRead(pThis->Base.pvThis, pszTarget, cbTarget);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
 
     return rc;
@@ -1877,7 +1833,7 @@
     RTSgBufInit(&SgBuf, &Seg, 1);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnRead(pThis->Base.pvThis, -1 /*off*/, &SgBuf, fBlocking, pcbRead);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1898,7 +1854,7 @@
     RTSgBufInit(&SgBuf, &Seg, 1);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnWrite(pThis->Base.pvThis, -1 /*off*/, &SgBuf, fBlocking, pcbWritten);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1916,7 +1872,7 @@
     AssertReturn(fBlocking || pcbRead, VERR_INVALID_PARAMETER);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnRead(pThis->Base.pvThis, -1 /*off*/, pSgBuf, fBlocking, pcbRead);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1934,7 +1890,7 @@
     AssertReturn(fBlocking || pcbWritten, VERR_INVALID_PARAMETER);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnWrite(pThis->Base.pvThis, -1 /*off*/, pSgBuf, fBlocking, pcbWritten);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1947,7 +1903,7 @@
     AssertReturn(pThis->uMagic == RTVFSIOSTREAM_MAGIC, VERR_INVALID_HANDLE);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnFlush(pThis->Base.pvThis);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1961,7 +1917,7 @@
     AssertReturn(pThis->uMagic == RTVFSIOSTREAM_MAGIC, VERR_INVALID_HANDLE);
 
-    rtVfsObjWriteLock(&pThis->Base);
+    RTVfsLockAcquireWrite(pThis->Base.hLock);
     int rc = pThis->pOps->pfnPollOne(pThis->Base.pvThis, fEvents, cMillies, fIntr, pfRetEvents);
-    rtVfsObjWriteUnlock(&pThis->Base);
+    RTVfsLockReleaseWrite(pThis->Base.hLock);
     return rc;
 }
@@ -1975,7 +1931,7 @@
 
     RTFOFF off;
-    rtVfsObjReadLock(&pThis->Base);
+    RTVfsLockAcquireRead(pThis->Base.hLock);
     int rc = pThis->pOps->pfnTell(pThis->Base.pvThis, &off);
-    rtVfsObjReadUnlock(&pThis->Base);
+    RTVfsLockReleaseRead(pThis->Base.hLock);
     if (RT_FAILURE(rc))
         off = rc;
@@ -1994,7 +1950,7 @@
     if (pThis->pOps->pfnSkip)
     {
-        rtVfsObjWriteLock(&pThis->Base);
+        RTVfsLockAcquireWrite(pThis->Base.hLock);
         rc = pThis->pOps->pfnSkip(pThis->Base.pvThis, cb);
-        rtVfsObjWriteUnlock(&pThis->Base);
+        RTVfsLockReleaseWrite(pThis->Base.hLock);
     }
     else
@@ -2007,7 +1963,7 @@
             {
                 size_t cbToRead = RT_MIN(cb, _64K);
-                rtVfsObjWriteLock(&pThis->Base);
+                RTVfsLockAcquireWrite(pThis->Base.hLock);
                 rc = RTVfsIoStrmRead(hVfsIos, pvBuf, cbToRead, true /*fBlocking*/, NULL);
-                rtVfsObjWriteUnlock(&pThis->Base);
+                RTVfsLockReleaseWrite(pThis->Base.hLock);
                 if (RT_FAILURE(rc))
                     break;
@@ -2033,7 +1989,7 @@
     if (pThis->pOps->pfnSkip)
     {
-        rtVfsObjWriteLock(&pThis->Base);
+        RTVfsLockAcquireWrite(pThis->Base.hLock);
         rc = pThis->pOps->pfnZeroFill(pThis->Base.pvThis, cb);
-        rtVfsObjWriteUnlock(&pThis->Base);
+        RTVfsLockReleaseWrite(pThis->Base.hLock);
     }
     else
@@ -2046,7 +2002,7 @@
             {
                 size_t cbToWrite = RT_MIN(cb, _64K);
-                rtVfsObjWriteLock(&pThis->Base);
+                RTVfsLockAcquireWrite(pThis->Base.hLock);
                 rc = RTVfsIoStrmWrite(hVfsIos, pvBuf, cbToWrite, true /*fBlocking*/, NULL);
-                rtVfsObjWriteUnlock(&pThis->Base);
+                RTVfsLockReleaseWrite(pThis->Base.hLock);
                 if (RT_FAILURE(rc))
                     break;
@@ -2158,7 +2114,7 @@
 
                 /** @todo there is a symlink creation race here. */
-                rtVfsObjWriteLock(&pVfsParentDir->Base);
+                RTVfsLockAcquireWrite(pVfsParentDir->Base.hLock);
                 rc = pVfsParentDir->pOps->pfnOpenFile(pVfsParentDir->Base.pvThis, pszEntryName, fOpen, phVfsFile);
-                rtVfsObjWriteUnlock(&pVfsParentDir->Base);
+                RTVfsLockReleaseWrite(pVfsParentDir->Base.hLock);
 
                 RTVfsDirRelease(pVfsParentDir);