Index: trunk/debian/rules
===================================================================
--- trunk/debian/rules	(revision 32543)
+++ trunk/debian/rules	(revision 34319)
@@ -245,8 +245,12 @@
 	dh_link \
 	    $(if $(NOQT),,usr/bin/VBox          usr/bin/VirtualBox) \
+	    $(if $(NOQT),,VirtualBox            usr/bin/virtualbox) \
 	    usr/bin/VBox                        usr/bin/VBoxManage \
+	    VBoxManage                          usr/bin/vboxmanage \
 	    $(if $(HEADLESS),,usr/bin/VBox      usr/bin/VBoxSDL) \
+	    $(if $(HEADLESS),,VBoxSDL           usr/bin/vboxsdl) \
 	    $(if $(ose),,usr/bin/VBox           usr/bin/VBoxVRDP) \
 	    usr/bin/VBox                        usr/bin/VBoxHeadless \
+	    VBoxHeadless                        usr/bin/vboxheadless \
 	    $(if $(NOWEBSVC),,usr/bin/VBox      usr/bin/vboxwebsrv) \
 	    usr/share/virtualbox/src/vboxhost   usr/src/vboxhost-$(ver)
@@ -300,5 +304,5 @@
 	  -Vpulse=$(if $(HEADLESS),,libpulse0) \
 	  -Vsdlttf=$(if $(HEADLESS),,libsdl-ttf2.0-0) \
-	  -Vdkms=$(if $(filter _Ubuntu_hardy _Ubuntu_intrepid _Ubuntu_jaunty _Ubuntu_karmic _Ubuntu_lucid,$(debrel)),dkms,)
+	  -Vdkms=$(if $(filter _Debian_etch _Debian_lenny,$(debrel)),,dkms)
 	dh_md5sums
 	dh_builddeb --destdir $(pkgdir)
Index: trunk/debian/templates
===================================================================
--- trunk/debian/templates	(revision 32543)
+++ trunk/debian/templates	(revision 34319)
@@ -2,6 +2,6 @@
 Type: note
 Description: Creating group 'vboxusers'
- Users of VirtualBox must be members of that group. Host network interfaces
- will be assigned to that group.
+ Users of VirtualBox must be members of this group. Host network interfaces
+ will be assigned to this group.
 Description-de.UTF-8: Erzeuge Gruppe 'vboxusers'
  Nutzer von VirtualBox müssen Mitglied dieser Gruppe sein. Hostinterfaces
@@ -12,7 +12,7 @@
 Description: Compilation of the kernel module FAILED!
  VirtualBox will not start until this problem is fixed. Please consult
- /var/log/vbox-install.log to find out why the kernel module does not compile.
- Most probably the kernel sources were not found. Install them (the package
- name is probably linux-headers-<version> whereby <version> can be determined
+ /var/log/vbox-install.log to find out why the kernel module didn't compile.
+ The kernel sources were probably not found. Install them (the package
+ name is probably linux-headers-<version> where <version> can be determined
  by 'uname -r') and execute
    
@@ -39,10 +39,10 @@
  .
  Without a suitable kernel module you will not be able to start any VMs. It is
- strongly recommended to compile a kernel module now. The kernel headers and
- the tools to build kernel modules (gcc, make, binutils, ...) are required.
+ strongly recommended that you compile a kernel module now. This requires
+ kernel headers and the tools to build kernel modules (gcc, make, binutils, ...).
  However if you know that a suitable kernel module already exists at another
  location, you might want to override the default by setting
- KDIR=<full_path_to_vboxdrv_module> in /etc/default/virtualbox. The
- compilation can also be done later by executing
+ KDIR=<full_path_to_vboxdrv_module> in /etc/default/virtualbox. You can also
+ build the module later by executing
    
    /etc/init.d/vboxdrv setup
@@ -68,7 +68,7 @@
 Default: true
 Description: Delete old vboxdrv kernel modules?
- Old vboxdrv kernel modules found. It is recommended to purge these modules as they
- might interfere with this version of VirtualBox. The module re-compilation
- can be forced later by executing
+ Old vboxdrv kernel modules found. You should remove these modules as they
+ might interfere with this version of VirtualBox. You can force re-compilation
+ of the module later by executing
    
    /etc/init.d/vboxdrv setup
@@ -99,6 +99,6 @@
 Type: note
 Description: Running VMs found
- A copy of VirtualBox is currently running.  Please close it and try again. Please note
- that it can take up to ten seconds for VirtualBox (in particular the VBoxSVC daemon) to
+ VirtualBox is currently running. Please close it and try again. Please note that it
+ can take up to ten seconds for VirtualBox (in particular the VBoxSVC daemon) to
  finish running.
 Description-de.UTF-8: VirtualBox VMs werden ausgeführt